<?php
/**********************************************************************
    Copyright (C) FrontAccounting, LLC.
	Released under the terms of the GNU General Public License, GPL, 
	as published by the Free Software Foundation, either version 3 
	of the License, or (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
    See the License here <http://www.gnu.org/licenses/gpl-3.0.html>.
***********************************************************************/
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/includes/ui/items_cart.inc");

//--------------------------------------------------------------------------------

function add_to_order(&$order, $new_item, $new_item_qty, $standard_cost, $batch_no=null, $exp_date = null, $mapped_units= '')
{
    //if ($order->find_cart_item($new_item))
         //display_error(_("For Part :") . $new_item . " " . "This item is already on this document. You can change the quantity on the existing line if necessary.");
	//else
	if($mapped_units != ALL_TEXT){
		$mapped_qty =FA_GetSingleValue("item_units_map",'qty',array('stock_id'=>$new_item,'unit'=>$mapped_units));
		$new_item_qty *=$mapped_qty;
		$standard_cost =$standard_cost/$mapped_qty;
	}

    $order->add_to_cart (count($order->line_items), $new_item, $new_item_qty, $standard_cost, null, $batch_no, $exp_date, $mapped_units);
}

//--------------------------------------------------------------------------------
function display_order_header(&$order){
	global $Refs;

	start_outer_table(TABLESTYLE2, "width='70%'"); // outer table
	table_section(1);

	locations_list_row(_("Location:"), 'StockLocation', null, false, false, $order->fixed_asset);
    date_row(_("Date:"), 'AdjDate', '', true);

	table_section(2, "50%");

	ref_row(_("Reference:"), 'ref', '', $Refs->get_next(ST_INVADJUST, null, array('location'=>get_post('StockLocation'), 'date'=>get_post('AdjDate'))),
		 false, ST_INVADJUST);

	end_outer_table(1); // outer table
}

//---------------------------------------------------------------------------------
function display_adjustment_items($title, &$order){
	global $path_to_root;

	$kv_batch = get_company_pref('kv_batch');
	$kv_exp_date = get_company_pref('kv_exp_date');
	display_heading($title);
    div_start('items_table');
	start_table(TABLESTYLE, "width='90%'");

	if ($order->fixed_asset) {
		$th = array(_("Item Code"), _("Item Description"), _("Quantity"),		_("Unit"), _("Unit Cost"), _("Initial Value"), "");
	} else {
		$th = array(_("Item Code"), _("Item Description"), _("QOH"), _("Quantity"),	_("Unit"), _("Unit Cost"), _("Total"));
		if ( count($order->line_items)) $th[] = '';
	}
	//if ( count($order->line_items)) $th[] = '';
	
	if(!$order->fixed_asset){
		if($kv_exp_date){
			array_splice( $th, 2, 0, _("Batch No") );
			array_splice( $th, 3, 0, _("Exp Date") );
		}elseif($kv_batch){
			array_splice( $th, 2, 0, _("Batch No") );
			//array_splice( $th, 3, 0, _("") );
		}
	}
	table_header($th);
	$total = 0;
	$k = 0;  //row colour counter

	$low_stock = $order->check_qoh($_POST['StockLocation'], $_POST['AdjDate']);
	$id = get_post('selected_id', find_submit('Edit'));
	foreach ($order->line_items as $line_no=>$stock_item)	{

		$standard_cost =$stock_item->standard_cost;
		$quantity =$stock_item->quantity;

		$mapped_qty =1;
		if($stock_item->mapped_units != ALL_TEXT){
			$mapped_qty =FA_GetSingleValue("item_units_map",'qty',array('stock_id'=>$stock_item->stock_id,'unit'=>$stock_item->mapped_units));
			$quantity =$stock_item->quantity/$mapped_qty;
			$standard_cost *=$mapped_qty;
		}

		$total += ($standard_cost * $quantity);

		if ($id != $line_no)
		{
			if (in_array($stock_item->stock_id, $low_stock))
				start_row("class='stockmankobg'");	// notice low stock status
			else 
				alt_table_row_color($k);

    		if ($order->fixed_asset)
				label_cell($stock_item->stock_id);
      		else
				view_stock_status_cell($stock_item->stock_id);

			label_cell($stock_item->item_description);
			$dec = get_qty_dec($stock_item->stock_id);
    		if (!$order->fixed_asset)	{
				if($kv_exp_date){
					label_cell($stock_item->batch_no);
					label_cell($stock_item->exp_date);
				}elseif($kv_batch) 
					label_cell($stock_item->batch_no);
			}
			label_cell('');
    		qty_cell($quantity, false, $dec);
			if($stock_item->mapped_units){
    			label_cell($stock_item->mapped_units);
    		}else{
    			label_cell($stock_item->units);
    		}
			amount_cell($standard_cost);

			if ($order->fixed_asset) {
    	   		$price = get_purchase_value($stock_item->stock_id);
				amount_cell($price);
      		} else
				amount_cell($standard_cost * $quantity);

      		if (!$order->fixed_asset) {
      			if ($id == -1)
	        		edit_button_cell("Edit$line_no", _("Edit"),	_('Edit document line'));
	        	else
	        		label_cell('');
      		}
    		if ($id == -1)
				delete_button_cell("Delete$line_no", _("Delete"), _('Remove line from document'));
        	else
        		label_cell('');
			
			end_row();
		}
		else
		{
			adjustment_edit_item_controls($order, $line_no, $kv_batch, $kv_exp_date);
		}
	}

	if ($id == -1)
		adjustment_edit_item_controls($order, -1, $kv_batch, $kv_exp_date);
	//$row = !$order->fixed_asset ? 6 : 5;
	if($kv_batch|| $kv_exp_date)
		$colspan = 8;
	else
		$colspan= 7; 

	label_row(_("Total"), number_format2($total,user_price_dec()), "align=right colspan=$colspan", "align=right", 2);

    end_table();

	if ($id != -1)
	    hidden('selected_id', $id);
	if ($low_stock)
		display_note(_("Marked items have insufficient quantities in stock as on day of adjustment."), 0, 1, "class='stockmankofg'");
	div_end();
}

//---------------------------------------------------------------------------------

function adjustment_edit_item_controls(&$order, $line_no=-1, $kv_batch=0, $kv_exp_date=0){
	global $Ajax;
	start_row();

	if(list_updated('mapped_units'))
		$Ajax->activate('items_table');
	$dec =$dec2 = 0;

	if ($line_no != -1)	{
		if (find_submit('Edit') != -1) {
			hidden('Edit'.find_submit('Edit'));
			$_POST['stock_id'] = $order->line_items[$line_no]->stock_id;
			$qty =$order->line_items[$line_no]->quantity;
			$std_cost =$order->line_items[$line_no]->standard_cost;

			if($order->line_items[$line_no]->mapped_units != ALL_TEXT){
				if(!list_updated('mapped_units')){
					$_POST['mapped_units'] = $order->line_items[$line_no]->mapped_units;
				}
				$mapped_qty =FA_GetSingleValue("item_units_map",'qty',array('stock_id'=>$order->line_items[$line_no]->stock_id,'unit'=>$order->line_items[$line_no]->mapped_units));
				$qty =$qty/$mapped_qty;
				$std_cost =$std_cost*$mapped_qty;
			}
		}
		$_POST['qty'] = qty_format($qty, $order->line_items[$line_no]->stock_id, $dec);
		$_POST['std_cost'] = price_decimal_format($std_cost, $dec2);
		$_POST['units'] = $order->line_items[$line_no]->units;
		if($order->line_items[$line_no]->mapped_units != ALL_TEXT){
			$_POST['units'] = $order->line_items[$line_no]->mapped_units;
		}
		
		hidden('stock_id', $_POST['stock_id']);
		label_cell($_POST['stock_id']);
		label_cell($order->line_items[$line_no]->item_description, 'nowrap');
		hidden('batch_no', $order->line_items[$line_no]->batch_no);
		hidden('exp_date', $order->line_items[$line_no]->exp_date);
		if($kv_exp_date){
			label_cell($order->line_items[$line_no]->batch_no);
			label_cell($order->line_items[$line_no]->exp_date);
		} if($kv_batch)
			label_cell($order->line_items[$line_no]->batch_no);

	    $Ajax->activate('items_table');
	}	else	{
		if ($order->fixed_asset)
			stock_disposable_fa_list_cells(null, 'stock_id', null, false, true, $order->line_items);
		else
			stock_costable_items_list_cells(null, 'stock_id', null, false, true);

		if (list_updated('stock_id')) {
			$Ajax->activate('items_table');
		}
		if($kv_batch || $kv_exp_date){
			text_cells(null,'batch_no', null, 25, 25);//kv_batch_list_cells(null, 'batch_no', null, true);
			
		}else
			hidden('batch', 0);
		if(list_updated('stock_id') || list_updated('batch_no') || get_post('batch_no')){				
			if($kv_exp_date) {
				date_cells(null, 'exp_date', null);
			}
			if(!isset($_POST['qty']))
			$_POST['qty'] = 0;
		}else {
			if( $kv_exp_date)
			date_cells(null, 'exp_date', null);
		}

		$item_info = get_item_edit_info(get_post('stock_id'));
		if ($item_info) {
			$dec = $item_info['decimals'];
			$_POST['std_cost'] = price_decimal_format($item_info["material_cost"], $dec2);
			$_POST['units'] = $item_info["units"];
		} else
			$dec = 0;
		$mapped_qty =1;
		if(isset($_POST['mapped_units']) && $_POST['mapped_units'] !=ALL_TEXT){
			$mapped_qty =FA_GetSingleValue("item_units_map",'qty',array('stock_id'=>$_POST['stock_id'],'unit'=>$_POST['mapped_units']));
			$_POST['std_cost'] *=$mapped_qty;
		}	
	}

	if ($order->fixed_asset) {
		hidden('qty', -1);
		qty_cell(1, false, 0);
	} else {
		$qoh = get_qoh_on_date(get_post('stock_id'), $_POST['StockLocation']);
		label_cell(number_format2($qoh, $dec).' '.get_post('units'));
		label_cell( text_input('qty', get_post('qty', '0'), 15, 15, '',  'class="amount active" dec='.$dec), "nowrap align=right");
	}
	if(!isset($_POST['units']))
		$_POST['units'] = '';
	stock_mapped_units_list_cell($_POST['stock_id'],null, 'mapped_units', null,$_POST['units'],true, $_POST['units']);

	if ($order->fixed_asset) {
		hidden('std_cost');
		label_cell($_POST['std_cost'], "nowrap align=right ", 'std_cost_view');
		$price = get_purchase_value($_POST['stock_id']);
		amount_cell($price, false, '', 'initial_price');
	} else {
		if (get_post('_qty_changed')) {
			$Ajax->activate('items_table');
			set_focus(input_num('qty') >= 0 ? 'std_cost' : 'AddItem');
		}
		if (input_num('qty') >= 0)
		    amount_cells(null, 'std_cost', null, null, null, user_price_dec());
		else {
		    hidden('std_cost');
			label_cell($_POST['std_cost'], "nowrap align=right");
		}
		amount_cell($_POST['std_cost']*input_num('qty'));
	}

	if ($line_no != -1)
	{
		button_cell('UpdateItem', _("Update"),		_('Confirm changes'), ICON_UPDATE);
		button_cell('CancelItemChanges', _("Cancel"),		_('Cancel changes'), ICON_CANCEL);
		hidden('LineNo', $line_no);
		set_focus('qty');
	}
	else
	{
		submit_cells('AddItem', _("Add Item"), "colspan=2",	    _('Add new item to document'), true);
	}

	end_row();
}

//---------------------------------------------------------------------------------
function adjustment_options_controls(){
	  echo "<br>";
	  start_table();
	  textarea_row(_("Memo"), 'memo_', null, 50, 3);

	  end_table(1);
}
//---------------------------------------------------------------------------------
